
/*
SM
*/
#include <stdlib.mqh> 
#property indicator_chart_window
extern string Subject="Other";          // The header of the message. 
extern bool Market=true;                // Send the notification for opened and closed orders.
extern bool Pending=true;               // Send the notification for pending and cancelled orders.
extern bool Date=true;                  // Show time orders.    
int h,r,g,t;
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
//---
   int L=OrdersTotal();
   int H=OrdersHistoryTotal();
   bool b=false;
   datetime date,today;
   int i,e,k,n,z,cmd,handle,time,digits,total,c,f;
   double x[100],s,y;
   string type[]={"Buy","Sell","Buy Limit","Sell Limit","Buy Stop","Sell Stop"};
   string symbol,q[100],p,tp,sl,ex,text[100],d;

//----------------- counting pending and opened orders
   for(i=0; i<L; i++)
     {
      if(OrderSelect(i,SELECT_BY_POS,MODE_TRADES)==true)
        {
         cmd=OrderType();
         if(cmd<2)
           {
            c++;
           }
         else
           {
            if(cmd>1 && cmd<6)
              {
               f++;
              }
           }
        }
     }
//--------------------------------- for pending and opened orders  
   if(c!=g || f!=r)
     {
      today=iTime(NULL,PERIOD_D1,0);
      handle=FileOpen("Lile.bin",FILE_BIN|FILE_READ|FILE_WRITE);
      if(handle<0)
        {
         Alert("SM. Error: "+ErrorDescription(GetLastError())+". L");
         c=g;
         f=r;
         return(0);
        }
      //----
      for(i=0; i<L; i++)
        {
         if(OrderSelect(i,SELECT_BY_POS,MODE_TRADES)==true)
           {
            cmd=OrderType();
            y=OrderOpenTime()+i*0.01;
            if(Market==true && cmd<2)
              {
               x[total]=y;
               total++;
              }
            else
              {
               if(Pending==true && cmd>1 && cmd<6)
                 {
                  x[total]=y;
                  total++;
                 }
              }
           }
        }
      //----
      for(n=0; n<total; n++)
        {
         s=9000000000;
         for(i=n; i<total; i++)
           {
            if(s>x[i])
              {
               s=x[i];
               e=i;
              }
           }
         x[e]=x[n];
         x[n]=s;
        }
      //----
      FileSeek(handle,-4,SEEK_END);
      n=FileReadInteger(handle,INT_VALUE);
      for(i=0; i<total; i++)
        {
         e=MathFloor(x[i]);
         y=NormalizeDouble(100*(x[i]-e),0);
         z=y;
         if(OrderSelect(z,SELECT_BY_POS,MODE_TRADES)==true)
           {
            date=OrderOpenTime();
            time=date;
            if(n<time && date>=today)
              {
               e=FileWriteInteger(handle,time,INT_VALUE);
               if(e==-1)
                 {
                  Alert("SM. Error: "+ErrorDescription(GetLastError())+". L1");
                  c=g;
                  f=r;
                  return(0);
                 }
               cmd=OrderType();
               symbol=OrderSymbol();
               digits=MarketInfo(symbol,MODE_DIGITS);
               p=DoubleToStr(OrderOpenPrice(),digits);
               tp=DoubleToStr(OrderTakeProfit(),digits);
               sl=DoubleToStr(OrderStopLoss(),digits);
               if(Date==true) d=TimeToStr(date,TIME_DATE|TIME_MINUTES)+"  ";
               text[k]=d+type[cmd]+"  "+symbol+"  at: "+p+"  sl: "+sl+"  tp: "+tp;
               q[k]="New market order:";
               if(cmd>1) q[k]="New pending order:";
               if(Subject!="Other") q[k]=Subject;
               k++;
              }
           }
        }
      FileClose(handle);
      //----Send emails
      for(n=0; n<k; n++)
        {
         if(t==1)
           {
            b=SendMail(q[n],text[n]);
            if(b==false) Alert("The notification by an order "+text[n]+" has not been sent!\nError: "+ErrorDescription(GetLastError())+"");
           }
        }
      c=g;
      f=r;
     }
//------------------------------------- for closed and cancelled orders
   if(h!=H)
     {
      k=0;
      today=iTime(NULL,PERIOD_D1,0);
      handle=FileOpen("Hist.bin",FILE_BIN|FILE_READ|FILE_WRITE);
      if(handle<0)
        {
         Alert("SM. Error: "+ErrorDescription(GetLastError())+". H");
         h=H;
         return(0);
        }
      //----
      total=0;
      for(i=H-1; i>H-36; i--)
        {
         if(OrderSelect(i,SELECT_BY_POS,MODE_HISTORY)==true)
           {
            cmd=OrderType();
            y=OrderCloseTime()+i*0.00001;
            if(Market==true && cmd<2)
              {
               x[total]=y;
               total++;
              }
            else
              {
               if(Pending==true && cmd>1 && cmd<6)
                 {
                  x[total]=y;
                  total++;
                 }
              }
           }
        }
      //----
      for(n=0; n<total; n++)
        {
         s=9000000000;
         for(i=n; i<total; i++)
           {
            if(s>x[i])
              {
               s=x[i];
               e=i;
              }
           }
         x[e]=x[n];
         x[n]=s;
        }
      //----
      FileSeek(handle,-4,SEEK_END);
      n=FileReadInteger(handle,INT_VALUE);
      for(i=0; i<total; i++)
        {
         e=MathFloor(x[i]);
         y=NormalizeDouble(100000*(x[i]-e),0);
         z=y;
         if(OrderSelect(z,SELECT_BY_POS,MODE_HISTORY)==true)
           {
            date=OrderCloseTime();
            time=date;
            if(n<time && date>=today)
              {
               e=FileWriteInteger(handle,time,INT_VALUE);
               if(e==-1)
                 {
                  Alert("SM. Error: "+ErrorDescription(GetLastError())+". H1");
                  h=H;
                  return(0);
                 }
               cmd=OrderType();
               symbol=OrderSymbol();
               digits=MarketInfo(symbol,MODE_DIGITS);
               p=DoubleToStr(OrderClosePrice(),digits);
               tp=DoubleToStr(OrderTakeProfit(),digits);
               sl=DoubleToStr(OrderStopLoss(),digits);
               if(Date==true) d=TimeToStr(date,TIME_DATE|TIME_MINUTES);
               q[k]="Market order closed:";
               text[k]=type[cmd]+"  "+symbol+"  sl: "+sl+"  tp: "+tp+"   "+d+"    at: "+p;
               if(cmd>1)
                 {
                  p=DoubleToStr(OrderOpenPrice(),digits);
                  text[k]=type[cmd]+"  "+symbol+"  at: "+p+"  sl: "+sl+"  tp: "+tp+"   "+d;
                  q[k]="Pending order cancelled:";
                 }
               if(Subject!="Other") q[k]=Subject;
               k++;
              }
           }
        }
      FileClose(handle);
      //----Send emails
      for(n=0; n<k; n++)
        {
         if(t==1)
           {
            b=SendMail(q[n],text[n]);
            if(b==false) Alert("The notification by an order "+text[n]+" has not been sent!\nError: "+ErrorDescription(GetLastError())+"");
           }
        }
      h=H;
     }
   t=1;
   return(0);
  }
//+------------------------------------------------------------------+
